%define major           3
%define libwraster      %mklibname wraster %major
%define libwrasterdev   %mklibname wraster -d

%define shortname       wmaker
%define wmaker_vendor   crm
%define snapshot        a3c99bddc891cbd4cae233421920b83acc733186
%define _pixdir         %{_datadir}/pixmaps
%define gnustepdir      %{_prefix}/GNUstep

%define wmmajor         2
%define libname         %mklibname wings %{wmmajor}
%define libnamedev      %mklibname wings -d

# count incrementally snapshots of the prerel 0.95.3
%define snapshot_no     20120330

Name:           windowmaker
Version:        0.95.3
Release:        %mkrel 0.snapshot%{snapshot_no}.6
Summary:        A window manager for the X Window System
License:        GPLv2+
Group:          Graphical desktop/WindowMaker
URL:            http://windowmaker.org/
Source0:        http://repo.or.cz/w/%{shortname}-%{wmaker_vendor}.git/snapshot/%{snapshot}.tar.gz

Patch0:         %{name}-0.95.3-snapshot20120330-mga-disable-wmlib-build.patch

# (kamil) preconfigure default settings
# this patch has to be divided into two parts later
Patch3:         %{name}-0.95.2-mga-Mageia-preconfigured-desktop.patch

# (cjw) try to implement _NET_WM_MOVERESIZE events, required by gtk+3 (though that appears to be a bug)
Patch22:	wmaker-0.94.0-net_wm_moveresize.patch

Requires:	gcc-cpp
Requires:	desktop-common-data
Requires:	xdg-compliance-menu
Requires:       task-x11

Obsoletes:      WindowMaker
Obsoletes:      windowmaker-libs
Obsoletes:      WindowMaker-kde
Obsoletes:      WindowMaker-gnome
Obsoletes:      WindowMaker-common

BuildRequires:  libxft-devel
BuildRequires:  libxinerama-devel
BuildRequires:  libhermes-devel
BuildRequires:  libjpeg-devel
BuildRequires:  libpng-devel
BuildRequires:  libtiff-devel
BuildRequires:  libungif-devel
BuildRequires:  libxpm-devel
BuildRequires:  mawk
BuildRequires:  libPropList-devel
BuildRequires:  libxmu-devel

Requires:       windowmaker-desktop = %{version}

%description
Window Maker is a X11 window manager which emulates the look and feel of the
NeXTSTEP (TM) graphical user interface. It is relatively fast, feature rich and
easy to configure and use. Window Maker is part of the official GNU project,
which means that Window Maker can interoperate with other GNU projects, such as
GNOME.

Window Maker allows users to switch themes 'on the fly,' to place favorite
applications on either an application dock, similar to AfterStep's Wharf or on
a workspace dock, a 'clip' which extends the application dock's usefulness.


%files -f WindowMaker.lang
%doc AUTHORS BUGFORM BUGS ChangeLog COPYING.WTFPL FAQ FAQ.I18N NEWS README* TODO
%{_bindir}/*
%{_sysconfdir}/X11/WindowMaker/
%{_sysconfdir}/X11/wmsession.d/*
%{gnustepdir}/Applications/WPrefs.app/
%{_mandir}/man[18]/*
%lang(cs) %{_mandir}/cs/man1/*
%lang(ru) %{_mandir}/ru/man1/*
%lang(sk) %{_mandir}/sk/man1/*
%{_datadir}/WindowMaker
%{_datadir}/WINGs/

# --------------------------------------------

%package -n %{libwraster}
Summary:        Window Maker Raster Graphics Library
Group:          Graphical desktop/WindowMaker
Provides:       libwraster
Conflicts:      libwraster2

%description -n %{libwraster}
Also known as libwraster, it is WindowMaker's core graphics and image
processing system. libwraster is an optimized, fast, lightweight image library.
It takes advantage of MMX optimizations (on systems that have support for it)
to accelerate rendering. You can load a picture from a file easily with
libwraster, and it has support for .gif, .jpg, .png, .xpm, .ppm, and .tiff at
the moment. Support for other image formats can be added in the future.


This package contains a shared library needed if you wish use WindowMaker.


%files -n %{libwraster}
%{_libdir}/libwraster.so.%{major}
%{_libdir}/libwraster.so.%{major}.*

# --------------------------------------------

%package -n %{libwrasterdev}
Summary:        Window Maker Raster Graphics Library development files	
Group:          Development/C
Requires:       %{libwraster} = %{version}-%{release}
Provides:       libwraster-devel
Conflicts:      libwraster2-devel
Obsoletes:      %{mklibname wraster 3 -d}

%description -n %{libwrasterdev}
This package allows building applications using the libwraster library.


%files -n %{libwrasterdev}
%{_includedir}/wraster.h
%{_libdir}/libwraster.so

# --------------------------------------------

%package -n %{libname}
Summary:	Runtime libraries for Window Maker
Group:		System/Libraries

%description -n %{libname}
Window Maker is an X11 window manager which emulates the look and feel of the
NeXTSTEP (TM) graphical user interface. It is relatively fast, feature rich and
easy to configure and use. Window Maker is part of the official GNU project,
which means that Window Maker can interoperate with other GNU projects, such as
GNOME.

Window Maker allows users to switch themes 'on the fly,' to place favorite
xapplications on either an application dock, similar to AfterStep's Wharf or on
a workspace dock, a 'clip' which extends the application dock's usefulness.

This package contains shared libraries used by WindowMaker.


%files -n %{libname}
%{_libdir}/libWINGs.so.%{wmmajor}
%{_libdir}/libWINGs.so.%{wmmajor}.*
%{_libdir}/libWUtil.so.%{wmmajor}
%{_libdir}/libWUtil.so.%{wmmajor}.*

# --------------------------------------------

%package -n %{libnamedev}
Summary:        Libraries and header files for Window Maker
Group:          Development/C
Requires:       %{libwrasterdev} = %{version}-%{release}
Obsoletes:      %{mklibname WindowMaker 0 -d}
Obsoletes:      %{mklibname WindowMaker -d}
Obsoletes:      windowmaker-devel
Obsoletes:      WindowMaker-devel

%description -n %{libnamedev}
Window Maker is an X11 window manager which emulates the look and feel of the
NeXTSTEP (TM) graphical user interface. It is relatively fast, feature rich and
easy to configure and use. Window Maker is part of the official GNU project,
which means that Window Maker can interoperate with other GNU projects, such as
GNOME.

Window Maker allows users to switch themes 'on the fly,' to place favorite
xapplications on either an application dock, similar to AfterStep's Wharf or on
a workspace dock, a 'clip' which extends the application dock's usefulness.

This package contains headers needed for development.


%files -n %{libnamedev}
%{_libdir}/libWINGs.so
%{_libdir}/libWUtil.so
%{_includedir}/WINGs
%{_libdir}/pkgconfig/*.pc

# --------------------------------------------

%prep
%setup -q -n %{shortname}-%{wmaker_vendor}
%patch0 -p0
%patch22 -p1 -b .netwm-moveresize
%patch3 -p0

%build
# incorrect spelling (mga#4022) in menu.fr
sed -i 's/Verrouiller/Vérrouiller/' WindowMaker/menu.fr

#add to menus in all languages xdg support (and do not replace the original menu since it contains windowmaker-specific commands)
pushd WindowMaker
    for file in menu.* menu
    do
        #loop over a list of common programs, if a program is in the line - then delete it
        for prog_list in \
            firefox gimp ghostview xpdf abiword dia ooffice oowriter oocalc oodraw ooimpress xemacs emacs xjed "xterm -e vi" gvim nedit xedit xmms xine mplayer xv xpainy xfig xfm files lyx netscape "\/usr\/local\/Acrobat3\/bin\/acroread" tkdesk xfte xpaint xmcd xplaycd xmixer "xterm -T \"GNU plot\"" xephem xmupad xxgdb editres maze spider xboard xeyes xlogo xroach xtetris xvier xgas xkobo xboing xbill civ runxdos "xterm -T 'Joe'" xdvi "xterm -name mail" mule "kterm -e vi" gv xdvi xspread xwpe xminicom bitmap arena seyon workbone xlander xmahjongg "ULUB_TERM -e vi" "ULUB_TERM -T \"Midnight Commander\"" "ULUB_TERM -T \"GNU plot\"" "ULUB_TERM -e lynx" "ULUB_TERM -T \"Program pocztowy Pine\"" "ULUB_TERM -T \"Program pocztowy Elm\"" xmh "ULUB_TERM -e telnet" "ULUB_TERM -e ssh" "ULUB_TERM -e ftp" "ULUB_TERM -e irc" "ULUB_TERM -e ping" "ULUB_TERM -e talk"
        do
            sed -r "/EXEC $prog_list$/ d" -i $file
            sed -r "/EXEC $prog_list / d" -i $file
        done
        #delete empty lines
        sed -r "/^(\t| )*$/ d" -i $file

        #insert xdg menu
        #1)determine "application" string in a language
        applications_lang=`cat $file|grep "\" WORKSPACE_MENU" -A 1|sed "/WORKSPACE_MENU/ d"|cut -d \" -f 2`
     
        #exception for menu.es....
        [ "$file" = "menu.es" ] && applications_lang="Applications"
        #2)put xdg menu just after the WORKSPACE_MENU entry
        sed -r "/\"( )*WORKSPACE_MENU/ a\
        \"$applications_lang\" OPEN_MENU \$(HOME)/GNUstep/Defaults/menu.xdg" -i $file

	#fix for menu.pl, I don't know why it fails here
        [ "$file" = "menu.pl" ] && sed -r 's/\"\" OPEN_MENU/\"Aplikacje\" OPEN_MENU/' -i $file
        
        #delete empty MENU-END entries (without elements inside)
        #3x because empty menus can be nested
        sed '$!N;/ MENU.*\n.* END/d;P;D' -i $file
        sed '$!N;/ MENU.*\n.* END/d;P;D' -i $file
        sed '$!N;/ MENU.*\n.* END/d;P;D' -i $file

        #fix WPrefs path in menus
        sed -r "s@/usr/local/GNUstep@/usr/GNUstep@g" -i $file
    done
popd #WindowMaker

# protect the WPrefs.app location for unclean build envs with gnustep-make installed
unset GNUSTEP_LOCAL_ROOT

LINGUAS=`(cd po ; echo *.po | sed 's/.po//g')`
export LINGUAS
autoreconf -fi
%configure2_5x --prefix=%_prefix \
    --sysconfdir=%{_sysconfdir}/X11 \
    --with-nlsdir=%{_datadir}/locale \
    --with-pixmapdir=%{_pixdir} \
    --with-gnustepdir=%{gnustepdir} \
    --enable-xinerama \
    --enable-usermenu \
    --enable-xrandr \
    --with-pic \
    --with-x

%make

%install
%makeinstall_std

# Config files: Auto installation
cat << EOF >  %{buildroot}%{_bindir}/startwindowmaker
if [ ! -d ~/GNUstep/Library/WindowMaker ]; then
    yes | wmaker.inst

    # modifications to use Mageia menus
    cp -vfR /usr/share/WindowMaker/Icons/* ~/GNUstep/Library/Icons
    cp -vfR /usr/share/WindowMaker/Styles/* ~/GNUstep/Library/WindowMaker/Styles
    cp -vfR /usr/share/WindowMaker/Themes/* ~/GNUstep/Library/WindowMaker/Themes
    cp -vfR /usr/share/WindowMaker/Backgrounds/* ~/GNUstep/Library/WindowMaker/Backgrounds
    cp -vfR /usr/share/WindowMaker/IconSets/* ~/GNUstep/Library/WindowMaker/IconSets
    cp -vfR /usr/share/WindowMaker/Pixmaps/* ~/GNUstep/Library/WindowMaker/Pixmaps

    # (kamil) 0.9.5-15.mga2 - renamed Galaxy.style to Mageia.style
    setstyle /usr/share/WindowMaker/Themes/Mageia.style
    
    cp /etc/X11/WindowMaker/{WMGLOBAL,WMState} ~/GNUstep/Defaults/
    
fi

# set NLSPATH - mandatory to get correct locale!
export NLSPATH=/usr/share/locale

exec /usr/bin/wmaker $@

EOF

chmod 0755 %{buildroot}%{_bindir}/startwindowmaker

# wmsession support
mkdir -p %{buildroot}%{_sysconfdir}/X11/wmsession.d/
cat << EOF > %{buildroot}%{_sysconfdir}/X11/wmsession.d/03WindowMaker
NAME=Window Maker
ICON=wmaker-wmsession.xpm
EXEC=%{_bindir}/startwindowmaker
DESC=Window manager which emulates the look and feel of the NeXTSTEP (TM) graphical user interface
SCRIPT:
exec %{_bindir}/startwindowmaker
EOF

%find_lang WPrefs
%find_lang WindowMaker
%find_lang WINGs
%find_lang wmgenmenu
cat WPrefs.lang >> WindowMaker.lang
cat WINGs.lang >> WindowMaker.lang
cat wmgenmenu.lang >> WindowMaker.lang

rm -f %{buildroot}%{_libdir}/*.a
rm -f %{buildroot}%{_libdir}/*.la

# these files are shipped with *-windowmaker-desktop
rm -fr %{buildroot}%{_datadir}/WindowMaker/autostart.sh
rm -fr %{buildroot}%{_sysconfdir}/X11/WindowMaker/WMState
rm -fr %{buildroot}%{_sysconfdir}/X11/WindowMaker/WMWindowAttributes
rm -fr %{buildroot}%{_sysconfdir}/X11/WindowMaker/WindowMaker


%changelog

* Thu Apr 19 2012 kamil <kamil> 0.95.3-0.snapshot20120330.6.mga2
+ Revision: 231864
- fix an incorrect spelling in menu.fr (mga#4022)

* Fri Apr 13 2012 kamil <kamil> 0.95.3-0.snapshot20120330.5.mga2
+ Revision: 230725
- drop requirement on themes in this package and move them to mageia-windowmaker-desktop

* Sun Apr 01 2012 kamil <kamil> 0.95.3-0.snapshot20120330.4.mga2
+ Revision: 227656
- exclude desktop configuration from this package and ship it as a stand-alone package

* Fri Mar 30 2012 kamil <kamil> 0.95.3-0.snapshot20120330.3.mga2
+ Revision: 227584
- add a missing suggestion for gvolwheel

* Fri Mar 30 2012 kamil <kamil> 0.95.3-0.snapshot20120330.2.mga2
+ Revision: 227575
- rediff Mageia-preconfigured-desktop.patch to execute polkit-gnome-authentication-agent-1 in autostart.sh

* Fri Mar 30 2012 kamil <kamil> 0.95.3-0.snapshot20120330.1.mga2
+ Revision: 227561
- update to the newest snapshot
- disable rarely used build of reincluded wmlib into the sources (linkage problems)

* Sun Feb 26 2012 kamil <kamil> 0.95.3-0.snapshot20120223.2.mga2
+ Revision: 215122
- add mgaapplet (mgaonline) to the autostart script
- rename P0 to Mageia-preconfigured-desktop.patch
- add new suggestions and use the software against the Mageia default desktop:
  o GVolWheel (Volume Applet in the system tray)
  o pulseaudio-utils (to wrap GVolWheel and use it agaist PulseAudio)
  o wmsystemtray (System Tray)
  o wmudmount (Mounter using Gnome libraries)

* Fri Feb 24 2012 kamil <kamil> 0.95.3-0.snapshot20120223.1.mga2
+ Revision: 213661
- drop all sources except S0
- stop installing extra Window Maker icons
- fix patches
- drop Source8 WindowMaker-startwindowmaker and merge cleaned script into .spec
- make networkmanager-applet and drakconf suggested
- new version 0.95.3 (2012-02-23 snapshot)
- drop P1, P2, P3 - merged upstream
- stop making non-western users happy by changing fonts (no more need for this)
- rediff P3, add drakconf to the default configuration and nm-applet to autostart

* Sun Feb 19 2012 kamil <kamil> 0.95.2-12.mga2
+ Revision: 210633
- drop old WindowMaker-Galaxy.style.bz2 file and include it renamed (new name is Mageia.style) to windowmaker-themes
- edit startwindowmaker and load Mageia.style on the first start by default
- stop using %%config(noreplace) for /etc/* files for this package, these files needs to be rewritten and not configured by user

* Sat Feb 18 2012 kamil <kamil> 0.95.2-11.mga2
+ Revision: 210496
- drop old WindowMaker-data with pixmaps, it's not really needed (Fedora, Debian don't include it)

* Sat Feb 18 2012 kamil <kamil> 0.95.2-10.mga2
+ Revision: 210200
- switch from old Mdk/Mdv/Mga WMWindowAttributes to the upstream one

* Sat Feb 18 2012 kamil <kamil> 0.95.2-9.mga2
+ Revision: 210195
- drop unused WindowMaker-Terminal

* Sat Feb 18 2012 kamil <kamil> 0.95.2-8.mga2
+ Revision: 210190
- stop using old Mageia (from Mandrake/Mandriva times) WMState
- use upstream WMState with some of the old behaviour thanks to P3 patch-WMState-to-use-old-Mageia-configuration.patch

* Sat Feb 18 2012 kamil <kamil> 0.95.2-7.mga2
+ Revision: 210154
- drop Mageia WMGLOBAL and use upstream one (they are nearly the same)

* Sat Feb 18 2012 kamil <kamil> 0.95.2-6.mga2
+ Revision: 210147
- use upstream /etc/X11/WindowMaker/WindowMaker configuration

* Fri Feb 17 2012 kamil <kamil> 0.95.2-5.mga2
+ Revision: 209912
- include P2 stop-using-old-X11R6-directory.patch switch from /usr/X11R6 to /usr

* Fri Feb 17 2012 kamil <kamil> 0.95.2-4.mga2
+ Revision: 209901
- include fix-paths-in- P1 fix-paths-in-german-plmenu.patch to fix hardcoded '/home/mawa'

* Fri Feb 17 2012 kamil <kamil> 0.95.2-3.mga2
+ Revision: 209878
- include P0 mga-install-missing-man-pages.patch to install all missing and forgotten man pages

* Thu Feb 16 2012 kamil <kamil> 0.95.2-2.mga2
+ Revision: 209858
- drop WindowMaker-0.80.1-man-pages.tar.bz2 it's merged upstream (in doc/)

* Wed Feb 15 2012 kamil <kamil> 0.95.2-1.mga2
+ Revision: 209167
- new version 0.95.2
- replace '%%rename' with 'Obsoletes'

* Sat Feb 11 2012 kamil <kamil> 0.95.1-1.mga2
+ Revision: 207137
- new version 0.95.1

* Sat Jan 14 2012 kamil <kamil> 0.95.0-3.mga2
+ Revision: 195883
- fix plmenu.de
- fix LINGUAS and change it to determine languages dynamically
- enable xrandr in configure

* Fri Jan 13 2012 kamil <kamil> 0.95.0-2.mga2
+ Revision: 195469
- drop wmCalClock which was built-in and change it into an external dependency

* Thu Jan 12 2012 kamil <kamil> 0.95.0-1.mga2
+ Revision: 195432
- drop fix-WPrefs-path-in-menus.patch and implement it univerally in a script in .spec
- fix installation text in WindowMaker-wmaker.inst
- fix preparation of menu.pl in .spec script
- update VERSION to 0.95.0 in WindowMaker-wmaker.inst
- replace Mandriva with Mageia in WindowMaker-menumethod
- fix Obsoletes&Provides and use %%rename macro
- drop applications-menu.patch
- add script in .spec to fix universally all menu (no plmenu) files for all languages
- remove %%doc before man-pages
- remove NET_WM_NAME.patch, dropped in Debian (Debian maintainer is developing windowmaker)

* Thu Jan 12 2012 kamil <kamil> 0.95.0-0.mga2
+ Revision: 195085
- new version
- package name changed from WindowMaker to windowmaker
- spec cleaning

* Sun Sep 11 2011 fwang <fwang> 0.94.0-2.mga2
+ Revision: 142394
- drop empty section
- rebuild for new libpng

* Sat Jul 09 2011 cjw <cjw> 0.94.0-1.mga2
+ Revision: 120985
- add BuildRequires: libxmu-devel
- update to crm windowmaker 0.94.0+ git snapshot
- patch22: accept _NET_WM_MOVERESIZE events (without actually doing anything)
  to workaround apparently broken gtk+3 behavior
- drop patches 10, 11, 12, 14, 15, 16, 17, 18, 19, 20 - fixed upstream
- drop static library packages
- drop libtool libraries
- rename libWindowMaker to libwings

* Thu Jun 30 2011 cjw <cjw> 0.92.0-28.mga2
+ Revision: 116991
- generate applications menu in post if it doesn't exist yet

* Thu Jun 30 2011 cjw <cjw> 0.92.0-27.mga2
+ Revision: 116229
- add empty user.menu to fix applications submenu

  + ahmad <ahmad>
    - revert make_session commit, this is supposed to be handled by filetriggers
      (from Anssi)
    - add patch to fix WPrefs path in the menus
    - %%make_session is evaluated to %%nil, use %%make_dm_session instead

* Wed Feb 23 2011 ahmad <ahmad> 0.92.0-26.mga1
+ Revision: 57488
- drop old/unneeded scriptlets
- require mageia-theme
- imported package WindowMaker

